<?php
/*
Plugin Name: Builder Block - Events
Plugin URI: http://ithemes.com
Description: This Builder block adds events management to your site.
Version: 1.1.31
Author: iThemes
Author URI: http://ithemes.com
iThemes Package: builder-block-events
*/


function it_builder_block_events_invalid_theme_notice() {
	// Add a notice if a Builder theme is not running.
	if ( ! isset( $GLOBALS['it_builder_core_version'] ) && ( 'builder' != strtolower( get_template() ) ) )
		echo '<div class="error"><p>' . __( 'The Builder Block - Events plugin requires that a Builder theme is active in order for it to function.', 'it-l10n-builder-block-events' ) . '</p></div>';
}
add_action( 'admin_notices', 'it_builder_block_events_invalid_theme_notice' );


require_once( dirname( __FILE__ ) . '/lib/classes/load.php' );

if ( ! class_exists( 'BB_Events' ) ) {
	class BB_Events {
		
		function __construct() {
			load_plugin_textdomain( 'it-l10n-builder-block-events', false, dirname( plugin_basename( __FILE__ ) ) . '/lang' );
			
			add_action( 'it_libraries_loaded', array( $this, 'init' ) );
		}
		
		function init() {
			
			// Post Type & Taxonomies
			require_once( dirname( __FILE__ ) . '/lib/post-types/events.php' );
			require_once( dirname( __FILE__ ) . '/lib/post-types/venues.php' );
			
			// Extras
			require_once( dirname( __FILE__ ) . '/lib/extras/eventbrite.php' );
			require_once( dirname( __FILE__ ) . '/lib/extras/filters.php' );
			require_once( dirname( __FILE__ ) . '/lib/extras/images.php' );
			if ( get_option('permalink_structure') != '' ) {
				require_once( dirname( __FILE__ ) . '/lib/extras/menus.php' );
			}
			
			// Templates
			require_once( dirname( __FILE__ ) . '/templates/init.php' );
			
			if ( is_admin() ) {
				// Editor for the Events post type.
				require_once( dirname( __FILE__ ) . '/lib/editor/events/editor.php' );
				// Editor for the venues post type.
				require_once( dirname( __FILE__ ) . '/lib/editor/venues/editor.php' );
			}
			
			// The data handler for the settings pages.
			require_once( dirname( __FILE__ ) . '/lib/editor/events/data-handler.php' );
			require_once( dirname( __FILE__ ) . '/lib/editor/venues/data-handler.php' );
			
		}
	}
	
	new BB_Events();
}


function it_builder_block_events_updater_register( $updater ) {
	$updater->register( 'builder-block-events', __FILE__ );
}

add_action( 'ithemes_updater_register', 'it_builder_block_events_updater_register' );

require( dirname( __FILE__ ) . '/lib/updater/load.php' );
