var it_event_location_map;
var it_event_location_marker = null;
var it_event_location_directions_display = null;
var it_event_location_directions_service = null;

function updateMarkerPosition(latLng) {
	if(null === it_event_location_marker) {
		
		it_event_location_marker = new google.maps.Marker(
			{
				position:	latLng,
				map:		it_event_location_map,
				draggable:	true
			}
		);
		
		google.maps.event.addListener(it_event_location_marker, 'drag',
			function() {
				updateMarkerPosition(it_event_location_marker.getPosition());
			}
		);
	}
	
	it_event_location_marker.setPosition(latLng);
	
	jQuery('#marker_latitude').val(latLng.lat());
	jQuery('#marker_longitude').val(latLng.lng());
}

function updateMapCenter(latLng) {
	jQuery('#map_center_latitude').val(latLng.lat());
	jQuery('#map_center_longitude').val(latLng.lng());
}

function updateMapType(type) {
	jQuery('#map_type').val(type);
}

function updateMapZoom(zoom) {
	jQuery('#map_zoom').val(zoom);
}

function it_events_location_init() {
	it_event_location_directions_display = new google.maps.DirectionsRenderer();
	it_event_location_directions_service = new google.maps.DirectionsService();	
	
	var map_options = {
		center:		new google.maps.LatLng( 34.635865, -97.49497 ),
		mapTypeId:	google.maps.MapTypeId.ROADMAP,
		zoom:		3
	};
	
	if((jQuery("#map_center_latitude").val().length > 0) && (jQuery("#map_center_longitude").val().length > 0)) {
		if(!isNaN(jQuery("#map_center_latitude").val()) && !isNaN(jQuery("#map_center_longitude").val())) {
			map_options.center = new google.maps.LatLng(jQuery("#map_center_latitude").val(), jQuery("#map_center_longitude").val());
		}
	}
	if(jQuery("#map_type").val().length > 0) {
		map_options.mapTypeId = jQuery("#map_type").val();
	}
	if(jQuery("#map_zoom").val().length > 0) {
		map_options.zoom = parseInt(jQuery("#map_zoom").val());
	}
	
	it_event_location_map = new google.maps.Map(document.getElementById("map_canvas"), map_options);
	
	it_event_location_directions_display.setMap(it_event_location_map);
	
	if((jQuery("#marker_latitude").val().length > 0) && (jQuery("#marker_longitude").val().length > 0)) {
		if(!isNaN(jQuery("#marker_latitude").val()) && !isNaN(jQuery("#marker_longitude").val())) {
			updateMarkerPosition(new google.maps.LatLng(jQuery("#marker_latitude").val(), jQuery("#marker_longitude").val()));
		}
	}
	
	// Update current position info.
	updateMapCenter(it_event_location_map.getCenter());
	updateMapType(it_event_location_map.getMapTypeId());
	updateMapZoom(it_event_location_map.getZoom());
	
	// Add dragging event listeners.
	google.maps.event.addListener(it_event_location_map, 'click',
		function(event) {
			updateMarkerPosition(event.latLng);
		}
	);
	
	google.maps.event.addListener(it_event_location_map, 'center_changed',
		function() {
			updateMapCenter(it_event_location_map.getCenter());
		}
	);
	
	google.maps.event.addListener(it_event_location_map, 'maptypeid_changed',
		function() {
			updateMapType(it_event_location_map.getMapTypeId());
		}
	);
	
	google.maps.event.addListener(it_event_location_map, 'zoom_changed',
		function() {
			updateMapZoom(it_event_location_map.getZoom());
		}
	);
	
	jQuery("#locate_address_on_map").click(
		function() {
			var geocoder = new google.maps.Geocoder();
			
			var address = jQuery("#address").val();
			address = address.replace(/\s+/g, ' ');
			
			geocoder.geocode(
				{
					address:	address
				},
				function(responses) {
					if (responses && responses.length > 0) {
						it_event_location_map.fitBounds(responses[0].geometry.viewport);
						updateMapCenter(responses[0].geometry.location);
						updateMarkerPosition(responses[0].geometry.location);
					} else {
						jQuery("#failed-address-search").show();
						jQuery("#failed-address-search").fadeOut(2000);
					}
				}
			);
		}
	);
	
	jQuery("#locate_search_address_on_map").click(
		function() {
			var geocoder = new google.maps.Geocoder();
			
			var address = jQuery("#search_address").val();
			address = address.replace(/\s+/g, ' ');
			
			geocoder.geocode(
				{
					address:	address
				},
				function(responses) {
					if (responses && responses.length > 0) {
						it_event_location_map.fitBounds(responses[0].geometry.viewport);
						updateMapCenter(responses[0].geometry.location);
						updateMarkerPosition(responses[0].geometry.location);
					} else {
						jQuery("#failed-search-address-search").show();
						jQuery("#failed-search-address-search").fadeOut(2000);
					}
				}
			);
		}
	);
	
}

jQuery(document).ready(
	function() {
		
		// Don't run on the listing page
		if ( 'edit-php' == adminpage )
			return;
		
		jQuery("#search_address").keypress(
			function(event) {
				if ( 13 != event.keyCode )
					return true;
				jQuery("#locate_search_address_on_map").click();
					return false;
			}
		);
		
		it_events_location_init();
		
	}
);