var it_event_location_map;
var it_event_location_marker = null;
var it_event_location_directions_display = null;
var it_event_location_directions_service = null;

function updateMarkerPosition(latLng) {
	if(null === it_event_location_marker) {
		
		it_event_location_marker = new google.maps.Marker(
			{
				position:	latLng,
				map:		it_event_location_map,
				title: 'Event Location'
			}
		);
		
	}
}

function it_event_location_init() {
	it_event_location_directions_display = new google.maps.DirectionsRenderer();
	it_event_location_directions_service = new google.maps.DirectionsService();
	
	var map_options = {
		center:		new google.maps.LatLng(34.635865, -97.49497),
		mapTypeId:	google.maps.MapTypeId.ROADMAP,
		zoom:		1
	};
	
	if((jQuery("#map_center_latitude").val().length > 0) && (jQuery("#map_center_longitude").val().length > 0)) {
		if(!isNaN(jQuery("#map_center_latitude").val()) && !isNaN(jQuery("#map_center_longitude").val())) {
			map_options.center = new google.maps.LatLng(jQuery("#map_center_latitude").val(), jQuery("#map_center_longitude").val());
		}
	}
	if(jQuery("#map_type").val().length > 0) {
		map_options.mapTypeId = jQuery("#map_type").val();
	}
	if(jQuery("#map_zoom").val().length > 0) {
		map_options.zoom = parseInt(jQuery("#map_zoom").val());
	}
	
	it_event_location_map = new google.maps.Map(document.getElementById("map_canvas"), map_options);
	
	it_event_location_directions_display.setMap(it_event_location_map);
	it_event_location_directions_display.setPanel(document.getElementById("text-directions"));
	
	if((jQuery("#marker_latitude").val().length > 0) && (jQuery("#marker_longitude").val().length > 0)) {
		if(!isNaN(jQuery("#marker_latitude").val()) && !isNaN(jQuery("#marker_longitude").val())) {
			updateMarkerPosition(new google.maps.LatLng(jQuery("#marker_latitude").val(), jQuery("#marker_longitude").val()));
		}
	}
	
	jQuery("#directions_calculate_route").click(
		function() {
			var start = jQuery("#directions_origin").val();
			var end = it_event_location_marker.getPosition();
			var mode = jQuery("#directions_method").val();
			
			var request = {
				origin:						start,
				destination:				end,
				provideRouteAlternatives: 	true,
				travelMode:					google.maps.DirectionsTravelMode[mode]
			};
			
			it_event_location_directions_service.route(request, function(result, status) {
				if (status == google.maps.DirectionsStatus.OK) {
					it_event_location_directions_display.setDirections(result);
					jQuery("#text-directions, #map-and-directions .success, #map-and-directions .meta-box h4").show();
				}
				else {
//					console.log(status);
				}
			});
		}
	);
}

jQuery(document).ready(
	function() {
		var content_loop = jQuery('.builder-module-content .builder-module-element .loop');
		
		jQuery('.btn-content').click(function(){
			jQuery(this).removeClass("inactive").addClass("active");
			jQuery('.loop-content, .loop-footer', content_loop).removeClass("inactive").addClass("active");
			jQuery(".btn-calendar, .loop-calendar", content_loop).removeClass("active").addClass("inactive");
		});
		jQuery('.btn-calendar').click(function(){
			jQuery(this).removeClass("inactive").addClass("active");
			jQuery('.loop-calendar', content_loop).removeClass("inactive").addClass("active");
			jQuery(".btn-content, .loop-content, .loop-footer", content_loop).removeClass("active").addClass("inactive");
			jQuery('#calendar').fullCalendar( 'render' );
		});
		
		// Don't run on the listing page
		if ( null == document.getElementById("map_canvas") )
			return;
		
		it_event_location_init();
		
		var directions_input = jQuery("#directions_origin");
		if ( directions_input.length ) {
			directions_input.keypress(
				function(event) {
					if ( 13 != event.keyCode )
						return true;
					jQuery("#directions_calculate_route").click();
  						return false;
				}
			);
		}
		
	}
);
